/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the incident.
 */
@ApiModel(description = "Information related to the incident.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Incident {
  @SerializedName("discovered_at")
  private LocalDate discoveredAt = null;

  @SerializedName("baggage_arrived_at")
  private LocalDate baggageArrivedAt = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("location")
  private Model59 location = null;

  @SerializedName("concerned_items")
  private ConcernedItems concernedItems = null;

  @SerializedName("kind")
  private String kind = null;

  public Incident discoveredAt(LocalDate discoveredAt) {
    this.discoveredAt = discoveredAt;
    return this;
  }

   /**
   * Date and time when the loss or delay was discovered. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return discoveredAt
  **/
  @ApiModelProperty(value = "Date and time when the loss or delay was discovered. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getDiscoveredAt() {
    return discoveredAt;
  }

  public void setDiscoveredAt(LocalDate discoveredAt) {
    this.discoveredAt = discoveredAt;
  }

  public Incident baggageArrivedAt(LocalDate baggageArrivedAt) {
    this.baggageArrivedAt = baggageArrivedAt;
    return this;
  }

   /**
   * Date and time of arrival of the delayed baggage. UTC date-time, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return baggageArrivedAt
  **/
  @ApiModelProperty(value = "Date and time of arrival of the delayed baggage. UTC date-time, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getBaggageArrivedAt() {
    return baggageArrivedAt;
  }

  public void setBaggageArrivedAt(LocalDate baggageArrivedAt) {
    this.baggageArrivedAt = baggageArrivedAt;
  }

  public Incident description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the incident.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the incident.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Incident location(Model59 location) {
    this.location = location;
    return this;
  }

   /**
   * Get location
   * @return location
  **/
  @ApiModelProperty(value = "")
  public Model59 getLocation() {
    return location;
  }

  public void setLocation(Model59 location) {
    this.location = location;
  }

  public Incident concernedItems(ConcernedItems concernedItems) {
    this.concernedItems = concernedItems;
    return this;
  }

   /**
   * Get concernedItems
   * @return concernedItems
  **/
  @ApiModelProperty(value = "")
  public ConcernedItems getConcernedItems() {
    return concernedItems;
  }

  public void setConcernedItems(ConcernedItems concernedItems) {
    this.concernedItems = concernedItems;
  }

  public Incident kind(String kind) {
    this.kind = kind;
    return this;
  }

   /**
   * The different kind of incident that can occur. Expected values (LOSS, DELAY)
   * @return kind
  **/
  @ApiModelProperty(required = true, value = "The different kind of incident that can occur. Expected values (LOSS, DELAY)")
  public String getKind() {
    return kind;
  }

  public void setKind(String kind) {
    this.kind = kind;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Incident incident = (Incident) o;
    return Objects.equals(this.discoveredAt, incident.discoveredAt) &&
        Objects.equals(this.baggageArrivedAt, incident.baggageArrivedAt) &&
        Objects.equals(this.description, incident.description) &&
        Objects.equals(this.location, incident.location) &&
        Objects.equals(this.concernedItems, incident.concernedItems) &&
        Objects.equals(this.kind, incident.kind);
  }

  @Override
  public int hashCode() {
    return Objects.hash(discoveredAt, baggageArrivedAt, description, location, concernedItems, kind);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Incident {\n");
    
    sb.append("    discoveredAt: ").append(toIndentedString(discoveredAt)).append("\n");
    sb.append("    baggageArrivedAt: ").append(toIndentedString(baggageArrivedAt)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    concernedItems: ").append(toIndentedString(concernedItems)).append("\n");
    sb.append("    kind: ").append(toIndentedString(kind)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

